#ifndef LOG_H
#define LOG_H

#include <stdio.h>

typedef enum
{
    DH5TOOL_LOG_FATAL = 1,
    DH5TOOL_LOG_ERR   = 2,
    DH5TOOL_LOG_WARN  = 3,
    DH5TOOL_LOG_INFO  = 4,
    DH5TOOL_LOG_DBG   = 5
} DH5TOOL_loglevel;

#define LOG(level, ...) do {  \
        if (level <= DH5TOOL_debug_level) { \
            fprintf(DH5TOOL_debug_stream,"%d:%s:%d:", DH5TOOL_global_rank, __FILE__, __LINE__); \
            fprintf(DH5TOOL_debug_stream, __VA_ARGS__); \
            fprintf(DH5TOOL_debug_stream, "\n"); \
            fflush(DH5TOOL_debug_stream); \
        } \
    } while (0)

extern int DH5TOOL_global_rank;
extern FILE *DH5TOOL_debug_stream;
extern DH5TOOL_loglevel DH5TOOL_debug_level;

#endif /* LOG_H */
